SystemOrganization addCategory: #'XMLRPC-Server-Core'!

!SmallInteger methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:54'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w |
	w := WriteStream on: (String new: 50).
	w nextPutAll: '<value><i4>'; nextPutAll: self asString; nextPutAll: '</i4></value>'.
	^ w contents! !

!Float methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:51'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w | 
	w := WriteStream
				on: (String new: 50).
	w nextPutAll: '<value><double>';
		 nextPutAll: self asString;
		 nextPutAll: '</double></value>'.
	^ w contents! !

!True methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/15/2011 19:58'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	^ '<value><boolean>1</boolean></value>'! !

!Dictionary methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:50'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w |
	w := WriteStream
				on: (String new: 200).
	w nextPutAll: '<value><struct>'.
	self
		keysAndValuesDo: [:key :value | 
			w nextPutAll: '<member><name>';
				 nextPutAll: key asString;
				 nextPutAll: '</name>'.
			w nextPutAll: value asXMLRPCString;
				 nextPutAll: '</member>'].
	w nextPutAll: '</struct></value>'.
	^ w contents! !

!False methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/15/2011 19:50'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"

	^ '<value><boolean>0</boolean></value>'! !

!XMLRPCDateTime methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:57'!
asXMLRPCString
	| str |
	str := WriteStream on: (String new: 70).
	str nextPutAll: '<value><dateTime.iso8601>'; nextPutAll:
	self encodeISO8601; nextPutAll: '</dateTime.iso8601></value>';cr.
	^ str contents! !

!SequenceableCollection methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:53'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w |
	w := WriteStream on: (String new: 200).
	w nextPutAll: '<value><array><data>'.
	self
		do: [:each | w nextPutAll: each asXMLRPCString].
	w nextPutAll: '</data></array></value>'.
	^ w contents! !

!ByteString methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 3/26/2011 11:38'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	"TO-DO Revisar, est como String por ahora"
"	^ '<value>' , self asString , '</value>' "
	
	| w |
	w := WriteStream on: String new.
	w nextPutAll: '<value>'; nextPutAll: self asString; nextPutAll: '</value>'.
	^ w contents! !

!Stream methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:55'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver. A stream will be
	encoded as an base64 (mimeencoded) element."
	| w |
	w := WriteStream on: String new.
	w nextPutAll: '<value><base64>';
		 nextPutAll: (Base64MimeConverter mimeEncode: self) contents;
		 nextPutAll: '</base64></value>'.
	^ w contents! !

!Object methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:52'!
asXMLRPCString
	"answer a XMLRPC struct that includes all instanceVariables of the 
	receiver. A XMLRPC struct is represented as a dictionary in squeak"
	| d |
	d := Dictionary new.
	self class instVarNames
		do: [:each | d
				at: each asSymbol
				put: (self instVarNamed: each)].
	d size > 0 ifTrue: [^ d asXMLRPCString].
	^'<value>nil</value>'! !

Object subclass: #XMLRPCErrorHandler
	instanceVariableNames: 'error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCErrorHandler commentStamp: '<historical>' prior: 0!
This is the error handler for XMLRPC errors!

!XMLRPCErrorHandler methodsFor: 'accessing' stamp: ''!
error
	"Answer the receiver's 'error'."

	^error! !

!XMLRPCErrorHandler methodsFor: 'accessing' stamp: ''!
error: anObject
	"Set the receiver's instance variable 'error' to be anObject."

	error := anObject! !

!XMLRPCErrorHandler methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/14/2012 11:54'!
errorMessage
	| str errorDict |
	errorDict := Dictionary new.
	
	(error class canUnderstand: #faultCode) ifTrue: [
		errorDict at: #faultCode put: error faultCode
	] ifFalse: [
		errorDict at: #faultCode put: 10
	]. 

	errorDict at: #faultString put: error messageText.
	
	str := WriteStream on: (String new: 1000).
	
	str 	nextPutAll: '<?xml version="1.0"?><methodResponse><fault>';
		nextPutAll: errorDict asXMLRPCString;
		nextPutAll: '</fault></methodResponse>'.
		
	^ str contents! !

Object subclass: #XMLRPCHttpModule
	uses: TLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

XMLRPCHttpModule class
	uses: TLogger classTrait
	instanceVariableNames: 'port service'!

!XMLRPCHttpModule commentStamp: '<historical>' prior: 0!
This comanche module handles incoming requests for a XMLRPC server!

XMLRPCHttpModule class
	uses: TLogger classTrait
	instanceVariableNames: 'port service'!

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/17/2012 15:55'!
alias
	 ^'/'.! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/17/2012 15:55'!
createServiceOnPort: aPort
	| serv xs ma |
	Smalltalk at: #HttpService ifPresent: [
		:hs | 
		
		self debug: [' Creating service based on HttpService on alias ', self alias].
		
		xs := XMLRPCHttpModule new.
		ma := ModuleAssembly core.
		ma 	alias: self alias to: [
				ma 	addPlug: [
					:request | 
					xs process: request
				]
		].
		serv := HttpService on: aPort.
		serv plug: ma rootModule.
		^ serv
	].

	Smalltalk at: #ComancheNetService ifPresent: [
		:cns | 

		self debug: [' Creating service based on ComancheNetService on alias ', self alias].
		^ (cns named: 'xmlrpc' onPort: port) module: self new
	]! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'GermanArduino 6/2/2011 18:46'!
initialize
	"Smalltalk addToStartUpList: self after: AutoStart."
	Smalltalk addToShutDownList: self! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/17/2012 15:53'!
pause
	self info: ' Stopping XMLRPC Server '.
	service ifNotNil: [
		self debug: ' Unregistering service '.
		service unregister.
		service := nil
	] ifNil:[
		self debug: ' Related service is poiting to Nil '.
	].
	self info: ' XMLRPC Server stopped'.! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'maf 3/1/2005 13:29'!
setDebugMode
	service setDebugMode.! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'maf 3/1/2005 13:29'!
setDeploymentMode
	service setDeploymentMode.! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'maf 3/1/2005 13:29'!
setVerboseMode
	service setVerboseMode.! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'maf 3/1/2005 13:30'!
shutdown
	self pause! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'maf 3/1/2005 19:10'!
start
	^ self startOn: 8081! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'maf 3/1/2005 17:11'!
startKom61
	^ self start! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/14/2012 13:02'!
startOn: aPort
	self startOn: aPort and: nil.! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/17/2012 15:51'!
startOn: aPort and: anAddress
	self stop.
	
	self info: ['Configuring XMLRPC Server with address: ', anAddress ,' port:', aPort asString].

	port := aPort.
	service := self createServiceOnPort: aPort.
	anAddress ifNotNil:[
		service address: anAddress.
	].

	self info: ['Starting XMLRPC Server at http://', anAddress ,':', aPort asString, '/'].
	service start! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'maf 3/1/2005 13:46'!
startUp
	port ifNotNil: [self startOn: port]! !

!XMLRPCHttpModule class methodsFor: 'as yet unclassified' stamp: 'maf 3/1/2005 13:29'!
stop
	self pause.
	port := nil.
! !

!XMLRPCHttpModule methodsFor: 'process' stamp: 'SantiagoBragagnolo 9/17/2012 15:44'!
process: request 


	self debug: 'Analyzing Request'.
	[
	 	| xrReq reqData |
		reqData := request propertyAt: #rawPostFields.
		xrReq := XMLRPCServerRequest fromRequest: reqData.
		xrReq targetURI: request url.
		^ HttpResponse fromMIMEDocument: (MIMEDocument contentType: 'text/xml' content: xrReq methodResponse)
		
	] on: Error do: [:e | 
		
		self logError: e errorMessage.
		^ HttpResponse fromMIMEDocument: (MIMEDocument contentType: 'text/xml' content: (XMLRPCErrorHandler new error: e) errorMessage)
	]! !

Object subclass: #XMLRPCServerRequest
	uses: TLogger
	instanceVariableNames: 'methodCall params targetURI'
	classVariableNames: 'Receivers'
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCServerRequest commentStamp: '<historical>' prior: 0!
This class holds all information about a XMLRPC request an coordinates the computation of a XMLRPC methodcall!

XMLRPCServerRequest class
	uses: TLogger classTrait
	instanceVariableNames: ''!

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/17/2012 15:57'!
cleanUpReceiverDictionary
	" deletes references to obsolete classes from the 'Receivers' dictionary"
	| removeThem |
	
	self debug: ['Cleaning up receiving dictionary: ' , self receivers ].
	removeThem := self receivers 	select: [ : each | each isObsolete ].
	removeThem keysDo: [ : key | self receivers removeKey: key ].
	! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/17/2012 15:59'!
fromRequest: xmlString 
	| xmldoc r parameters relatedSelector |
	
	self debug: ['Creating XMLRPCServerRequest from:', xmlString ].
	
	r := self new.
	parameters := OrderedCollection new.
	xmldoc := XMLDOMParser parseDocumentFrom: xmlString readStream.
	
	relatedSelector := ((xmldoc firstElement elementAt: #methodName) contentString).
	
	self info: ['Server requested for: ', relatedSelector ].
	r methodCall: relatedSelector.	
	[
		((xmldoc firstElement) elementAt: #params ) elements do: [
			:each | 
			parameters add: (XMLRPCDecoder new decode: each)
		].
		
	] on: Error do: [
		XMLRPCRequestError new signal: 'Could not decode request'
	].

	self info: ['Using parameters ', parameters ].
	r params: parameters.
	^ r! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: ''!
initialize
	Receivers := Dictionary new.! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/14/2012 11:56'!
receivers
	^Receivers ifNil: [Receivers := Dictionary new].! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/17/2012 16:01'!
registerService: serviceName class: aClass selector: aSelector 
	self info: ['Registering service: ', serviceName, ' Poting to #', aClass name asSymbol asString, '>>', aSelector asSymbol asString  ].
	self receivers at: serviceName asSymbol put: aClass -> aSelector! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2012 10:45'!
removeAllServices
	self info: ['Removing all services '].
	self receivers removeAll.! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/17/2012 16:01'!
removeService: aXMLRPCService
	self info: ['Removing service: ', aXMLRPCService asString ].
	self receivers removeKey: aXMLRPCService asSymbol! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
methodCall
	"Answer the receiver's 'methodCall'."

	^methodCall! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
methodCall: anObject
	"Set the receiver's instance variable 'methodCall' to be anObject."

	methodCall := anObject! !

!XMLRPCServerRequest methodsFor: 'invocation' stamp: 'SantiagoBragagnolo 9/19/2012 10:43'!
methodResponse
	| srv stream ret encodedReturn |
	
	" 
		Reach the method then executeit. If is not there a MessageNotFound is thrown. 
		TODO: show an error in case of method fail.
	"
	self flag: #lookAtTheComment.

	[
		self debug: ['Attempting to load [', methodCall ,'] service'].
		srv := (
		Receivers at: methodCall asSymbol ifAbsent: [
			self logError: ['There is not related service to: [', methodCall asSymbol asString, ']'].
			XMLRPCMethodError new signal: 'Serverside method not found'
			]
		).
		self debug: ['Attempting to call [', methodCall ,' service]'].
		ret := ((srv key) perform: (srv value) withArguments: (self params asArray)).		
		ret 	ifNil: [ret := false].
			
		self debug: ['Service call was successfull ', ret asString].
			
	] on: Error do: [
		:e | 
		self halt.
		self logError: ['Error calling service [', methodCall asSymbol asString, '] [', e messageText, ']'].
		XMLRPCMethodError new signal: 'Message not understood by server class: ', e messageText.
	] .
 "MessageNotUnderstood"
	
	" 
		If all the process of execution was right, just need to encode the response in the xml format. 
	"	
	[
		encodedReturn := ret asXMLRPCString.
	] on: Error do: [
		:e |
		self logError: ['Error trying to encode service [', methodCall asSymbol asString, '] response [', e messageText, ']'].
		
		XMLRPCReturnError new signal: 'Could not encode returned value "' , ret asString , '"'
	].
	
	
	stream := WriteStream on: String new.
	
	stream nextPutAll: '<?xml version="1.0"?><methodResponse><params><param>'.
	stream nextPutAll: encodedReturn.
	stream nextPutAll: '</param></params></methodResponse>'.
	
	self debug: [ 'XMLResponse: ', '<?xml version="1.0"?><methodResponse><params><param>', String cr, encodedReturn, String cr, '</param></params></methodResponse>'.].
	^ stream contents
	






! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
params
	"Answer the receiver's 'params'."

	^params! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
params: anObject
	"Set the receiver's instance variable 'params' to be anObject."

	params := anObject! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
targetURI
	"Answer the receiver's 'targetURI'."

	^targetURI! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
targetURI: anObject
	"Set the receiver's instance variable 'targetURI' to be anObject."

	targetURI := anObject! !

Object subclass: #XMLRPCStandardEcho
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCStandardEcho class methodsFor: 'as yet unclassified' stamp: 'Skrish 9/19/2010 10:31'!
addTests
	"XMLRPCStandardEcho addTests"

	XMLRPCServerRequest registerService: 'echo.echoArray' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoBinary' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoBoolean' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoDateTime' class: self  selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoDouble' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoInt' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoString' class: self selector: #echo:.
	XMLRPCServerRequest registerService: 'echo.echoStruct' class: self selector: #echo:! !

!XMLRPCStandardEcho class methodsFor: 'as yet unclassified' stamp: 'Skrish 9/19/2010 10:54'!
echo: aValue

   ^aValue first! !

Object subclass: #XMLRPCStandardValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: 'mfrit 11/25/2002 15:35'!
addTests
	"XMLRPCStandardValidator addTests"

	XMLRPCServerRequest registerService: 'validator1.arrayOfStructsTest' class: self selector: #arrayOfStructsTest:.
	XMLRPCServerRequest registerService: 'validator1.countTheEntities' class: self selector: #countTheEntities:.
	XMLRPCServerRequest registerService: 'validator1.echoStructTest' class: self selector: #echoStructTest:.
	XMLRPCServerRequest registerService: 'validator1.easyStructTest' class: self  selector: #easyStructTest:.
	XMLRPCServerRequest registerService: 'validator1.moderateSizeArrayCheck' class: self selector: #moderateSizeArrayCheck:.
	XMLRPCServerRequest registerService: 'validator1.nestedStructTest' class: self selector: #nestedStructTest:.
	XMLRPCServerRequest registerService: 'validator1.simpleStructReturnTest' class: self selector: #simpleStructReturnTest:.
	XMLRPCServerRequest registerService: 'validator1.manyTypesTest' class: self selector: #manyTypesTest:! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
arrayOfStructsTest: aCollection 
	| ret |
	ret := 0.
	aCollection first	do: [:each | ret := ret
								+ (each at: 'curly')].
	^ ret! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: 'M.F. 9/6/2002 16:42'!
countTheEntities: aCollection 
	| ret string |
	ret := Dictionary new.
	string := aCollection first.
	ret
		at: 'ctLeftAngleBrackets'
		put: (string occurrencesOf: $<).
	ret
		at: 'ctRightAngleBrackets'
		put: (string occurrencesOf: $>).
	ret
		at: 'ctAmpersands'
		put: (string occurrencesOf: $&).
	ret
		at: 'ctApostrophes'
		put: (string occurrencesOf: $').
	ret
		at: 'ctQuotes'
		put: (string occurrencesOf: $").
	^ ret! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
easyStructTest: aCollection
	| ret |
	ret := 0. aCollection first valuesDo: [ :each | ret := ret + each ].
	^ret! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: 'GermanArduino 3/26/2011 13:11'!
echoStructTest: aDictionary 

	^ aDictionary! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: 'Skrish 9/19/2010 10:49'!
manyTypesTest: aCollection
    "simply return the decoded values in aCollection encoded"
	| arr x | 
	x := 1.
	arr := Array new: 6.
	aCollection do: [ :each | arr at: x put: each. x := x+1].
	^arr ! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
moderateSizeArrayCheck: aCollection 
	| arr |
	arr := aCollection first.
	^ (arr first), (arr last)! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
nestedStructTest: aCollection
	| struct ret |
	struct := aCollection first.
	ret := 0.
	(((struct at: '2000') at: '04') at: '01') valuesDo: [ :each | ret := ret + each].
	^ ret! !

!XMLRPCStandardValidator class methodsFor: 'as yet unclassified' stamp: ''!
simpleStructReturnTest: aCollection 
	| num dict |
	dict := Dictionary new.
	num := aCollection first.
	dict at: 'times10' put: num * 10;
		 at: 'times100' put: num * 100;
		 at: 'times1000' put: num * 1000.
	^ dict! !

Error subclass: #XMLRPCError
	instanceVariableNames: 'faultCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCError commentStamp: '<historical>' prior: 0!
This is a generic error, it is raised if an unknown error has been detected.!

XMLRPCError subclass: #XMLRPCClassNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCClassNotFoundError commentStamp: '<historical>' prior: 0!
The request Class wasn't found!

!XMLRPCClassNotFoundError methodsFor: 'as yet unclassified' stamp: ''!
faultCode
	^ 1! !

!XMLRPCError methodsFor: 'accessing' stamp: ''!
faultCode
	"Answer the receiver's 'faultCode'."
	^ faultCode ifNil: [ ^0]! !

!XMLRPCError methodsFor: 'accessing' stamp: ''!
faultCode: anObject
	"Set the receiver's instance variable 'faultCode' to be anObject."

	faultCode := anObject! !

XMLRPCError subclass: #XMLRPCMethodError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCMethodError methodsFor: 'as yet unclassified' stamp: ''!
faultCode
	^ 2! !

XMLRPCError subclass: #XMLRPCRequestError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCRequestError commentStamp: '<historical>' prior: 0!
An error raised if a malformed request was found!

!XMLRPCRequestError methodsFor: 'as yet unclassified' stamp: ''!
faultCode
	^ 3! !

XMLRPCError subclass: #XMLRPCReturnError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCReturnError commentStamp: '<historical>' prior: 0!
An error occured while encoding a methodresponse!

!XMLRPCReturnError methodsFor: 'as yet unclassified' stamp: ''!
faultCode
	^ 4! !

!String methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:55'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w |
	w := WriteStream on: String new.
	w nextPutAll: '<value>'; nextPutAll: self asString; nextPutAll: '</value>'.
	^ w contents! !
XMLRPCHttpModule initialize!
XMLRPCServerRequest initialize!
